VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmBatchPrintStatements_Deposit 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Printing Deposit Statements of Account"
   ClientHeight    =   1560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6570
   Icon            =   "Batch Print Deposit Statements.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1560
   ScaleWidth      =   6570
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2558
      TabIndex        =   1
      Top             =   960
      Width           =   1455
   End
   Begin MSComctlLib.ProgressBar ProgressBar 
      Height          =   315
      Left            =   158
      TabIndex        =   0
      Top             =   360
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
End
Attribute VB_Name = "frmBatchPrintStatements_Deposit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Handles the batch printing of Deposit statements of account depending on the
'criteria set the parent parent form

Option Explicit

Private Loading As Boolean

Private Sub cmdCancel_Click()
    
    On Local Error Resume Next
    Printer.KillDoc
    Unload Me
    
End Sub

Private Sub Form_Activate()
    If CurrentUser.Allowed_DepositAc_BatchStmt Then
        DoBatchPrint
    Else
        GiveSecViolationMsg ("batch print Deposit A/c statements")
        Unload Me
    End If
        
End Sub

Private Sub DoBatchPrint()
    Dim strMsg As String
    
    Dim rstStudentsAffected As Recordset
    Dim rstCurrentStatement As Recordset
    Dim lngCounter As Long
        
    Dim strStudentID As String
    Dim strStudentName As String
    Dim strStudentClass As String
    Dim dtmStartDate As Date
    Dim dtmEndDate As Date
    
    Dim curOpeningBalance As Currency
    Dim curClosingBalance As Currency
    Dim curMinBalance As Currency
    Dim curCurrentBalance As Currency
    
    If Loading Then
        Loading = False
        ProgressBar.Value = 0
        Me.Refresh
        
        'Set the starting and ending dates
        dtmStartDate = frmBatchPrintStatements_StartUp.dtpickStartDate.Value
        dtmEndDate = frmBatchPrintStatements_StartUp.dtpickEndDate.Value
         
        'Get list of affected students
        Set rstStudentsAffected = GetListOfAffectedStudents
        
        'For each student, generate a statement and print it
        If rstStudentsAffected.RecordCount = 0 Then
            strMsg = "There are no students in the selected classes matching the specified criteria."
            MsgBox strMsg, vbExclamation, "Batch Print Levy Statements"
            Unload Me
        Else
            'Populate recordset and move to the first record
            rstStudentsAffected.MoveLast
            rstStudentsAffected.MoveFirst
            For lngCounter = 1 To rstStudentsAffected.RecordCount
                strStudentID = rstStudentsAffected("Student ID")
                strStudentName = rstStudentsAffected("Name")
                strStudentClass = rstStudentsAffected("Class")
                
                'Obtain balance
                curOpeningBalance = GetDepositOpeningBalance(strStudentID, dtmStartDate)
                curClosingBalance = GetDepositClosingBalance(strStudentID, dtmEndDate)
                curCurrentBalance = GetDepositClosingBalance(strStudentID, Now)
                curMinBalance = rstStudentsAffected("Min Balance")
                
                'Generate statement body excluding opening and closing balances
                Set rstCurrentStatement = GetDepositStatementBody(strStudentID, dtmStartDate, dtmEndDate)
                
                'Print statement
                Call PrintDepositStatement(strStudentID, strStudentName, strStudentClass, _
                                    dtmStartDate, dtmEndDate, curOpeningBalance, _
                                    curMinBalance, curCurrentBalance, _
                                    curClosingBalance, rstCurrentStatement)
                
                'Report progress
                ProgressBar.Value = Int(lngCounter / rstStudentsAffected.RecordCount * 100)
                Me.Refresh
                
                'Process external events e.g. Cancel button
                DoEvents
                rstStudentsAffected.MoveNext
            Next
            Printer.EndDoc
            Unload Me
        End If
    End If
    
End Sub

Private Function GetListOfAffectedStudents() As Recordset
    
    Dim HostList As ListBox
    Dim strSQL As String
    Dim lngCounter As Long
    Dim strClassCriteriaSet As String
    Dim rstAffectedStudents As Recordset
    Dim rstWorkAround As Recordset
    
    
    strSQL = "SELECT [Student ID], " _
          & "       ([Surname]&' '&[First Names]) as [Name], " _
          & "       [Class], " _
          & "       [Min Balance], " _
          & "       (IIF(isNull([Unrevised Debits]),0,([Unrevised Debits]))*-1) AS [Total Debits], " _
          & "       IIF (isNull([Unrevised Credits]),0,[Unrevised Credits]) AS  [Total Credits], " _
          & "       ([Total Credits] + [Total Debits]) AS Balance " _
          & "FROM  "
    strSQL = strSQL _
          & "( " _
          & "   SELECT DISTINCTROW " _
          & "        [Students].[Student ID] AS [Student ID], " _
          & "        [Students].[Surname] AS [Surname], " _
          & "        [Students].[First Names] AS [First Names], " _
          & "        [Students].[Class] AS [Class], " _
          & "        (SELECT  [Classes].[Minimum Balance] " _
          & "         FROM    [Classes] " _
          & "         WHERE   [Classes].[Class] = [Students].[Class] " _
          & "        ) As [Min Balance]," _
          & "        ( SELECT     Sum([Caution Fee Account Credits].[Amount]) " _
          & "          FROM       [Caution Fee Account Credits] " _
          & "          WHERE [Caution Fee Account Credits].[Student ID] = [Students].[Student ID] " _
          & "        )   AS [Unrevised Credits], " _
          & "        ( SELECT     Sum([Caution Fee Account Debits].[Amount]) " _
          & "          FROM [Caution Fee Account Debits] " _
          & "          WHERE [Caution Fee Account Debits].[Student ID] = [Students].[Student ID] " _
          & "        ) AS [Unrevised Debits] " _
          & "   FROM   [Students],[Classes], " _
          & "          [Caution Fee Account Debits], [Caution Fee Account Credits] " _
          & ") " _
          & "ORDER BY [Class],[Student ID]"
    
    
    
    'Reselect to factor in classes
    Set HostList = frmBatchPrintStatements_StartUp.lstSelectedClasses
    strClassCriteriaSet = "'" & Trim(HostList.List(0)) & "'"
    If HostList.ListCount > 1 Then
        For lngCounter = 1 To HostList.ListCount - 1
            strClassCriteriaSet = strClassCriteriaSet & ",'" & Trim(HostList.List(lngCounter)) & "'"
        Next
    End If
    strClassCriteriaSet = "(" & strClassCriteriaSet & ")"
    
    strSQL = "SELECT * " _
          & "FROM   (" & strSQL & ")" _
          & "WHERE  [Class] IN " & strClassCriteriaSet
    
    'Reselect to factor in balances criteria
    If frmBatchPrintStatements_StartUp.optAccrued.Value Then
        strSQL = "Select * from (" & strSQL & ") Where [Balance] < [Min Balance]"
    ElseIf frmBatchPrintStatements_StartUp.optPrepaid.Value Then
        strSQL = "Select * from (" & strSQL & ") Where [Balance] > [Min Balance]"
    ElseIf frmBatchPrintStatements_StartUp.optSettled.Value Then
        strSQL = "Select * from (" & strSQL & ") Where [Balance] = [Min Balance]"
    End If
    qryQueryObject.SQL = strSQL
    Set rstAffectedStudents = qryQueryObject.OpenRecordset
    
    
    Set GetListOfAffectedStudents = rstAffectedStudents
    
End Function



Private Sub Form_Load()
    Loading = True
End Sub
