VERSION 5.00
Begin VB.Form frmMailMerge_SearchAndReplace 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Search And Replace"
   ClientHeight    =   2640
   ClientLeft      =   1140
   ClientTop       =   1245
   ClientWidth     =   7035
   Icon            =   "Mail Merge Search and Replace Text.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2640
   ScaleWidth      =   7035
   Begin VB.CommandButton cmdReplaceAll 
      Caption         =   "Replace All"
      Height          =   345
      Left            =   5580
      TabIndex        =   11
      Top             =   1140
      Width           =   1245
   End
   Begin VB.CommandButton cmdReplace 
      Caption         =   "Replace"
      Height          =   345
      Left            =   5580
      TabIndex        =   10
      Top             =   660
      Width           =   1245
   End
   Begin VB.CommandButton cmdFindNext 
      Caption         =   "Find Next"
      Height          =   345
      Left            =   5580
      TabIndex        =   9
      Top             =   180
      Width           =   1245
   End
   Begin VB.TextBox txtReplacement 
      Height          =   285
      Left            =   1575
      TabIndex        =   5
      Top             =   675
      Width           =   3660
   End
   Begin VB.TextBox txtFindText 
      Height          =   285
      Left            =   1575
      TabIndex        =   3
      Top             =   255
      Width           =   3660
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   345
      Left            =   5580
      TabIndex        =   2
      Top             =   1620
      Width           =   1245
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   345
      Left            =   5580
      TabIndex        =   1
      Top             =   2100
      Width           =   1245
   End
   Begin VB.Frame fraOptions 
      Caption         =   "Options"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1110
      Left            =   180
      TabIndex        =   0
      Top             =   1200
      Width           =   5055
      Begin VB.CheckBox chkCaseSensitive 
         Caption         =   "Match Case"
         Height          =   240
         Left            =   600
         TabIndex        =   8
         Top             =   660
         Width           =   2625
      End
      Begin VB.CheckBox chkWholeWord 
         Caption         =   "Whole word"
         Height          =   285
         Left            =   600
         TabIndex        =   7
         Top             =   300
         Width           =   2490
      End
   End
   Begin VB.CommandButton cmdLoadReplace 
      Caption         =   "Replace ..."
      Default         =   -1  'True
      Height          =   345
      Left            =   5580
      TabIndex        =   12
      Top             =   1620
      Visible         =   0   'False
      Width           =   1245
   End
   Begin VB.Label lblReplaceWith 
      Caption         =   "Replace with"
      Height          =   285
      Left            =   225
      TabIndex        =   6
      Top             =   720
      Width           =   1230
   End
   Begin VB.Label Label1 
      Caption         =   "Find What"
      Height          =   300
      Left            =   225
      TabIndex        =   4
      Top             =   300
      Width           =   1185
   End
End
Attribute VB_Name = "frmMailMerge_SearchAndReplace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This form provides both the Search and the Search & Replace functions
'Before opening it, one must call either Remove_replace_functionality()
'or Add_replace_functionality() to specify the mode under which it should
'appear. The version without the replace functionality provides a button
'to add it.

Option Explicit

Private Sub cmdCancel_Click()
    'Don't unload the form otherwise you will lose 'Find Next' functionality
    
    Me.Hide
    frmMailMerge_MasterForm.SetFocus
End Sub

Private Sub cmdFindNext_Click()
    
    Dim blnWholeWord As Boolean
    Dim blnMatchCase As Boolean
    
    If chkCaseSensitive.Value = vbChecked Then blnMatchCase = True
    If chkWholeWord.Value = vbChecked Then blnWholeWord = True
    
    
    If txtFindText.Text <> "" Then
        Call Find_next(blnWholeWord, blnMatchCase)
    Else
        MsgBox "Please enter the text to locate", vbExclamation
    End If
    
End Sub

Private Sub cmdHelp_Click()
    
    LoadContextSensitiveHelp
    
End Sub

Private Sub LoadContextSensitiveHelp()
    If blnReplaceFunctionalityLoaded Then
        'show help topic fro search and replace
        ShowHelpTopic 1280
    Else
        'show topic for search only
        ShowHelpTopic 1270
    End If
End Sub
    
Private Sub cmdLoadReplace_Click()
    Add_replace_functionality
End Sub

Private Sub cmdReplace_Click()
    'Does one of the following depending on the situation
    ' - If nothing is selected, run a 'find next'
    ' - If something is selected then replace the current selection with
    '   the replace text and then run a 'find next'
    Dim blnWholeWord As Boolean
    Dim blnMatchCase As Boolean
    
    If chkCaseSensitive.Value = vbChecked Then blnMatchCase = True
    If chkWholeWord.Value = vbChecked Then blnWholeWord = True
    
    If txtFindText.Text <> "" Then
        If frmMailMerge_MasterForm.rtfMailMerge.SelText = "" Then
            Call Find_next(blnWholeWord, blnMatchCase)
        Else
            frmMailMerge_MasterForm.rtfMailMerge.SelText = txtReplacement.Text
            Call Find_next(blnWholeWord, blnMatchCase)
        End If
    Else
        MsgBox "Please enter the text to locate", vbExclamation
    End If
    
End Sub

Private Sub cmdReplaceAll_Click()
    'Replaces all the occurances of a given string within the text.
    'To aid the Undo system, all the replacement is done within a working
    'area with the final text being sent to the parent form. As a result, the
    'replacement will only count as one change to the text.
    
    Const blnOptReset = True
    Dim lngLocation As Long
    Dim lngReplacementsMade As Long
    Dim lngStartAt As Long
    Dim strMsg As String
    Dim strBeingSearched As String
    Dim strSearchText As String
    Dim blnWholeWord As Boolean
    Dim blnMatchCase As Boolean
    
    'Start at current insertion point
    lngStartAt = frmMailMerge_MasterForm.rtfMailMerge.SelStart + 1
    strSearchText = txtFindText.Text
    
    'Enforce options
    If chkCaseSensitive.Value = vbChecked Then blnMatchCase = True
    If chkWholeWord.Value = vbChecked Then blnWholeWord = True
    
    'Copy text on parent fom to a separate working area
    frmMailMerge_WorkingArea.rtfRichText.TextRTF = frmMailMerge_MasterForm.rtfMailMerge.TextRTF
    
    Do
        strBeingSearched = frmMailMerge_WorkingArea.rtfRichText.Text
        lngLocation = Embedded_in(lngStartAt, strBeingSearched, strSearchText, _
                                  blnWholeWord, blnMatchCase)
        If lngLocation = 0 Then
            If lngReplacementsMade = 0 Then
                MsgBox "Search text not found", vbExclamation, "Search And Replace"
            Else
                'send changed text to parent form
                frmMailMerge_MasterForm.rtfMailMerge.TextRTF _
                                    = frmMailMerge_WorkingArea.rtfRichText.TextRTF
                
                'reprt on number of replacements made
                strMsg = Str(lngReplacementsMade) & " replacements made."
                MsgBox strMsg, vbInformation, "Search and Replace"
            End If
            'EXITS HERE
            Exit Do
        Else
            'Keep track of replacements made
            lngReplacementsMade = lngReplacementsMade + 1
            
            'Do replacement
            With frmMailMerge_WorkingArea.rtfRichText
                .SelStart = lngLocation - 1
                .SelLength = Len(strSearchText)
                .SelText = txtReplacement.Text
            End With
            
            'Move search pointer
            lngStartAt = lngLocation + Len(txtReplacement.Text)
        End If
    Loop
    
    'Reset search so that next one starts at the beginning
    Call Find_next(, , blnOptReset)
    

End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyF1 Then
        LoadContextSensitiveHelp
        KeyCode = 0
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    'Allowing user unload would disable 'Find Next' functionality
    If UnloadMode = vbFormControlMenu Then
        Cancel = True
        Me.Hide
        frmMailMerge_MasterForm.SetFocus
    End If
        
End Sub

Private Sub txtFindText_Change()
    'Automatically prepare for new search if the search text has changed
    Const blnRequestReset = True
    Call Find_next(, , blnRequestReset)
    
End Sub

