SELECT * 
FROM   
(            SELECT       [Student ID],        
                                  [Surname],        
                                  [First Names],        
                                  [Class],        
                                  [Guardian Title],
                                  [Guardian Surname],
                                  [Guardian Initials],
                                  [Guardian Address],
                                  (IIF(isNull([Unrevised Debits]),0,([Unrevised Debits]))*-1) AS [Total Debits],        
                                  IIF (isNull([Unrevised Credits]),0,[Unrevised Credits]) AS  [Total Credits],        
                                  ([Total Credits] + [Total Debits]) AS Balance,        
                                  [Minimum],        
                                  ([Balance]-[Minimum]) as [Excess]  
             FROM          ( SELECT DISTINCTROW         
                                                   [Students].[Student ID] AS [Student ID],         
                                                   [Students].[Surname] AS [Surname],         
                                                   [Students].[First Names] AS [First Names],         
                                                   [Students].[Class] AS [Class],         
                                                   [Students].[Guardian Title]  AS  [Guardian Title],
                                                   [Students].[Guardian Surname]  AS  [Guardian Surname],
                                                   [Students].[Guardian Initials]  AS  [Guardian Initials],
                                                   [Students].[Guardian Address]  AS  [Guardian Address],
                                                   ( SELECT   [Classes].[Minimum Balance]           
                                                      FROM     [Classes]          
                                                      WHERE    [Classes].[Class] = [Students].[Class]        
                                                    )   AS [Minimum],          
                                                   ( SELECT    Sum([Caution Fee Account Credits].[Amount])          
                                                     FROM        [Caution Fee Account Credits]           
                                                     WHERE     [Caution Fee Account Credits].[Student ID] = [Students].[Student ID]        
                                                    )   AS [Unrevised Credits],         
                                                   ( SELECT    Sum([Caution Fee Account Debits].[Amount])           
                                                     FROM        [Caution Fee Account Debits]           
                                                     WHERE     [Caution Fee Account Debits].[Student ID] = [Students].[Student ID]         
                                                    ) AS [Unrevised Debits]    
                                     FROM   [Students], [Caution Fee Account Debits], [Caution Fee Account Credits] 
                                     ) 
              ORDER BY [Class],[Student ID]
)
WHERE  [Class] IN ('1A1','1A2','1A3','2A1','2A2','2A3')



